import _extends from 'babel-runtime/helpers/extends';
import AjaxUploader from './ajaxUploader.vue';
import UploadList from './uploadList.vue';
export default {
    name: "upload",
    prefixCls: 'sn-upload',
    data: function data() {
        return {
            fielList: this.defaultFileList || []
        };
    },

    props: {
        listType: function listType() {
            return 'text';
        }, // or pictrue
        disabled: function disabled() {
            return false;
        },
        beforeUpload: function beforeUpload() {
            return true;
        },
        showUploadList: function showUploadList() {
            return true;
        },
        action: ''
    },
    methods: {
        reBeforeUpload: function reBeforeUpload(file, files) {
            if (!this.beforeUpload) return true;
            var result = this.beforeUpload(file, files);
            if (result === false) {
                this.onChange({}); //
                return false;
            } else if (result && result.then) {
                return result;
            }
            return true;
        },
        renderUploadList: function renderUploadList() {
            var h = this.$createElement;
            var _$props = this.$props,
                showUploadList = _$props.showUploadList,
                listType = _$props.listType;

            var uploadListProps = {
                props: {
                    item: this.fielList,
                    listType: listType
                }

            };
            if (!showUploadList) return null;else return h(UploadList, uploadListProps);
        }
    },
    render: function render() {
        var h = arguments[0];

        var children = this.$slots['default'];
        var listType = this.$props.listType;

        var AjaxUploaderProps = {
            props: _extends({}, this.$props, {
                beforeUpload: this.reBeforeUpload
            })
        };

        var uploadList = this.renderUploadList();

        var uploadButton = h(
            AjaxUploader,
            AjaxUploaderProps,
            [' ', children]
        );
        if (listType === 'picture') {
            return h('div', [uploadList, uploadButton]);
        }
        return h('div', [uploadButton, uploadList]);
    }
};