'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _commonUtil = require('../utils/commonUtil');

var _functional = require('../_utils/functional');

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Cell = {
    functional: true,
    name: "ListItem",
    props: {
        icon: String,
        size: String,
        center: Boolean,
        isLink: Boolean,
        required: Boolean,
        clickable: Boolean,
        titleStyle: null,
        titleClass: null,
        valueClass: null,
        labelClass: null,
        title: [Number, String],
        value: [Number, String],
        label: [Number, String],
        arrowDirection: String,
        border: {
            type: Boolean,
            'default': true
        }
    },
    onClick: function onClick(event) {
        // emit(ctx, 'click', event);
        // functionalRoute(ctx);
    },
    render: function render(h, context) {
        console.log('list-item context === ', context);
        var props = context.props,
            scopedSlots = context.scopedSlots,
            data = context.data;
        var icon = props.icon,
            size = props.size,
            title = props.title,
            label = props.label,
            value = props.value,
            isLink = props.isLink,
            arrowDirection = props.arrowDirection;


        var showTitle = scopedSlots.title || (0, _commonUtil.isDef)(title);
        var showValue = scopedSlots['default'] || (0, _commonUtil.isDef)(value);
        var showLabel = scopedSlots.label || (0, _commonUtil.isDef)(label);

        var Label = showLabel && h(
            'div',
            { 'class': {
                    'sn-list-item-label': true,
                    '': props.labelClass
                } },
            [scopedSlots.label ? scopedSlots.label() : label]
        );

        var Title = showTitle && h(
            'div',
            {
                'class': {
                    'sn-list-item-title': true,
                    '': props.titleClass
                },
                style: props.titleStyle
            },
            [scopedSlots.title ? scopedSlots.title() : h('span', [title]), Label]
        );

        var Value = showValue && h(
            'div',
            { 'class': {
                    'sn-list-item-value': true,
                    alone: !scopedSlots.title && !title,
                    '': props.valueClass
                } },
            [scopedSlots['default'] ? scopedSlots['default']() : h('span', [value])]
        );

        var LeftIcon = scopedSlots.icon ? scopedSlots.icon() : icon && h(_icon2['default'], { 'class': 'sn-list-item-left-icon', attrs: { type: icon }
        });

        var rightIconSlot = scopedSlots['right-icon'];
        var RightIcon = rightIconSlot ? rightIconSlot() : isLink && h(_icon2['default'], {
            'class': 'sn-list-item-right-icon',
            attrs: { type: arrowDirection ? arrowDirection : 'right'
            }
        });

        var clickable = isLink || props.clickable;
        var classes = {
            'sn-list-item': true,
            'sn-list-item-clickable': clickable,
            'sn-list-item-center': props.center,
            'sn-list-item-required': props.required,
            'sn-list-item-borderless': !props.border
        };

        if (size) {
            classes[size] = size;
        }

        var domProps = (0, _extends3['default'])({}, data, {
            attrs: {
                role: clickable ? 'button' : null,
                tabindex: clickable ? 0 : null
            },
            'class': classes
        });

        return h(
            'div',
            domProps,
            [LeftIcon, Title, Value, RightIcon, scopedSlots.extra && scopedSlots.extra()]
        );
    }
};

exports['default'] = Cell;
module.exports = exports.default;