'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = {
    name: 'ajaxUploader',
    props: {
        multiple: function multiple() {
            return 'true';
        }, // or pictrue
        disabled: function disabled() {
            return false;
        },
        action: function action() {
            return '';
        }
    },
    data: function data() {
        return {
            index: 0,
            now: +new Date(),
            uid: this.getUid(),
            reqs: function reqs() {
                return [];
            }
        };
    },
    beforeDestroy: function beforeDestroy() {
        this.abort();
    },

    methods: {
        getUid: function getUid() {
            return 'vc-upload-' + this.now + '-' + ++this.index;
        },
        onClick: function onClick() {
            var el = this.$refs.fileInputRef;
            if (!el) {
                return;
            }
            el.click();
        },
        onChange: function onChange(e) {
            var files = e.target.files;
            this.uploadfiles(files);
        },
        uploadfiles: function uploadfiles(files) {
            var _this = this;

            var fileList = Array.prototype.slice.call(files);
            fileList.forEach(function (file) {
                file.uid = _this.getUid();
                _this.upload(file, fileList);
            });
        },
        upload: function upload(file, fileList) {
            var _this2 = this;

            if (!this.beforeUpload) {
                this.post(file);
                return;
            }
            var before = this.beforeUpload(file, fileList);
            if (before && before.then) {
                before.then(function (processFile) {
                    console && console.log(processFile);
                    _this2.post(file);
                })['catch'](function (e) {
                    console && console.log(e); // eslint-disable-line
                });
            } else if (before !== false) {
                this.post(file);
            }
        },
        post: function post(file) {
            var _this3 = this;

            var uid = file.uid;
            var action = this.$props.action;

            Mstp.init({
                appId: "433808474133",
                mstpId: "4563621431",
                exptime: '1592381275',
                creationTime: '1560845275',
                signature: "MGQEIGO1_lkeWNE7Mc5luQ74Q32kuATvFnVsgigLasmrJxr_BEBImrPRRQxvlvSZOBkoVLkVIx6t3kaLPXrzbnpDRXUKmxcs4Vkc-1eJccAzq9t7bD1j79G4smprak3srtg-tpCq",
                url: "https://mstpblackbox.sinosun.com",
                //url : "http://10.1.20.82:8999",
                log_level: 6 // 日志级别
            });
            this.reqs[uid] = Mstp.uploadDeirect({
                url: action,
                file: file,
                onProgress: function onProgress(progress) {
                    _this3.$emit('progress', progress, file);
                },
                onSuccess: function onSuccess(ret, xhr) {
                    delete _this3.reqs[uid];
                    _this3.$emit('success', ret, file, xhr);
                },
                onError: function onError(err, ret) {
                    delete _this3.reqs[uid];
                    _this3.$emit('error', err, ret, file);
                }
            });
        }
    },
    render: function render() {
        var h = arguments[0];
        var _$props = this.$props,
            multiple = _$props.multiple,
            disabled = _$props.disabled;

        var events = disabled ? {} : {
            click: this.onClick
        };
        var btnProps = {
            on: (0, _extends3['default'])({}, this.$listeners, events)
        };
        return h(
            'span',
            btnProps,
            [h('input', {
                attrs: {
                    type: 'file',

                    multiple: multiple
                },
                key: this.uid,
                ref: 'fileInputRef',
                style: { display: 'none' }, on: {
                    'change': this.onChange
                }
            }), this.$slots['default']]
        );
    }
};
module.exports = exports.default;