'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _ajaxUploader = require('./ajaxUploader.vue');

var _ajaxUploader2 = _interopRequireDefault(_ajaxUploader);

var _uploadList = require('./uploadList.vue');

var _uploadList2 = _interopRequireDefault(_uploadList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports['default'] = {
    name: "upload",
    prefixCls: 'sn-upload',
    data: function data() {
        return {
            fielList: this.defaultFileList || []
        };
    },

    props: {
        listType: function listType() {
            return 'text';
        }, // or pictrue
        disabled: function disabled() {
            return false;
        },
        beforeUpload: function beforeUpload() {
            return true;
        },
        showUploadList: function showUploadList() {
            return true;
        },
        action: ''
    },
    methods: {
        reBeforeUpload: function reBeforeUpload(file, files) {
            if (!this.beforeUpload) return true;
            var result = this.beforeUpload(file, files);
            if (result === false) {
                this.onChange({}); //
                return false;
            } else if (result && result.then) {
                return result;
            }
            return true;
        },
        renderUploadList: function renderUploadList() {
            var h = this.$createElement;
            var _$props = this.$props,
                showUploadList = _$props.showUploadList,
                listType = _$props.listType;

            var uploadListProps = {
                props: {
                    item: this.fielList,
                    listType: listType
                }

            };
            if (!showUploadList) return null;else return h(_uploadList2['default'], uploadListProps);
        }
    },
    render: function render() {
        var h = arguments[0];

        var children = this.$slots['default'];
        var listType = this.$props.listType;

        var AjaxUploaderProps = {
            props: (0, _extends3['default'])({}, this.$props, {
                beforeUpload: this.reBeforeUpload
            })
        };

        var uploadList = this.renderUploadList();

        var uploadButton = h(
            _ajaxUploader2['default'],
            AjaxUploaderProps,
            [' ', children]
        );
        if (listType === 'picture') {
            return h('div', [uploadList, uploadButton]);
        }
        return h('div', [uploadButton, uploadList]);
    }
};
module.exports = exports.default;